# lib_xtrap.mms (XTrap extensions/lib/xtrap MMS file)
#
TCPCONN        = 1                      ! yes,  build with TCP/IP
# DW_V3 = 1                             ! this is VMS DECwindows Vers 3

# The following logicals must be defined or these macros overriden
EXTDIR          = xtrap$ext:            ! external stuff to link with
USRBIN          = xtrap$bin:            ! where to install images
USRLIB          = xtrap$lib:            ! where to install libraries
USRINCLUDE      = xtrap$include:        ! where to install includes
#
X11             = decw$include:
SYS             = sys$library:
SRCBIN          = sys$disk:[]
SRCLIB          = sys$disk:[]
LIB             = $(SRCLIB)libXTrap.olb
IDIRS           = /include=(sys$disk:[],$(X11),$(SYS))
.ifdef TCPCONN
.ifdef DW_V3
DEFINES         = /define=(MBXCONN,DNETCONN,TCPCONN,VMSDW_V3,VERBOSE)
.else
DEFINES         = /define=(MBXCONN,DNETCONN,TCPCONN,VERBOSE)
.endif
.else
.ifdef DW_V3
DEFINES         = /define=(MBXCONN,DNETCONN,VMSDW_V3,VERBOSE)
.else
DEFINES         = /define=(MBXCONN,DNETCONN,VERBOSE)
.endif
.endif
CCOPTS          = /noopt/debug
CFLAGS          = $(IDIRS)$(CCOPTS)/list=$(SRCLIB)/obj=$(SRCLIB) $(DEFINES)
LDFLAGS         =
ECHO            = write sys$output
RM              = delete/noconfirm/log
AR              = library/replace
CP              = copy/log

INCLUDES = xtrapdi.h, xtraplibproto.h, xtraplib.h, \
           bits.h, xestream.h, xemacros.h

OBJLIB   = $(LIB)( \
         extutil=$(SRCLIB)extutil.obj \
         XETrapContext=$(SRCLIB)XETrapContext.obj \
         XEWrappers=$(SRCLIB)XEWrappers.obj \
         XECallbacks=$(SRCLIB)XECallbacks.obj \
         XEStream=$(SRCLIB)XEStream.obj \
         XEPrintInfo=$(SRCLIB)XEPrintInfo.obj \
         XETrapDispatch=$(SRCLIB)XETrapDispatch.obj \
         XEStreamFile=$(SRCLIB)XEStreamFile.obj \
         XEStreamInternetVMS=$(SRCLIB)XEStreamInternetVMS.obj \
         XEStreamDECnetVMS=$(SRCLIB)XEStreamDECnetVMS.obj \
         XEStreamMbxVMS=$(SRCLIB)XEStreamMbxVMS.obj \
         XEStreamLATVMS=$(SRCLIB)XEStreamLATVMS.obj \
         XETrapRequests=$(SRCLIB)XETrapRequests.obj \
         XEStringMapping=$(SRCLIB)XEStringMapping.obj \
         XETrapInit=$(SRCLIB)XETrapInit.obj \
         XEPrivUtilsVMS=$(SRCLIB)XEPrivUtilsVMS.obj \
         XLib_Global=$(SRCLIB)XLib_Global.obj \
         sleep=$(SRCLIB)sleep.obj \
         XEKeybCtrl=$(SRCLIB)XEKeybCtrl.obj \
         getopt=$(SRCLIB)getopt.obj )

all :    $(OBJLIB)
    $(ECHO) "Build complete."

clean :    
    $(RM) $(LIB);*,$(SRCLIB)*.obj;*,*.lis;*

install : 
    $(CP) $(LIB) $(USRLIB)
    $(CP) $(INCLUDES) $(USRINCLUDE)

# Module dependency definitions

$(SRCLIB)extutil.obj             : extutil.c extutil.h Xext.h

$(SRCLIB)XETrapContext.obj       : XETrapContext.c, $(INCLUDES)
$(SRCLIB)XEWrappers.obj          : XEWrappers.c, $(INCLUDES), InitializeI.h
$(SRCLIB)XECallbacks.obj         : XECallbacks.c, $(INCLUDES)
$(SRCLIB)XEStream.obj            : XEStream.c, $(INCLUDES)
$(SRCLIB)XEPrintInfo.obj         : XEPrintInfo.c, $(INCLUDES)
$(SRCLIB)XETrapDispatch.obj      : XETrapDispatch.c, $(INCLUDES)
$(SRCLIB)XEStreamFile.obj        : XEStreamFile.c, $(INCLUDES)
$(SRCLIB)XEStreamInternetVMS.obj : XEStreamInternetVMS.c, $(INCLUDES)
$(SRCLIB)XEStreamDECnetVMS.obj   : XEStreamDECnetVMS.c, $(INCLUDES)
$(SRCLIB)XEStreamMbxVMS.obj      : XEStreamMbxVMS.c, $(INCLUDES)
$(SRCLIB)XEStreamLATVMS.obj      : XEStreamLATVMS.c, $(INCLUDES)
$(SRCLIB)XETrapRequests.obj      : XETrapRequests.c, $(INCLUDES)
$(SRCLIB)XEStringMapping.obj     : XEStringMapping.c, $(INCLUDES)
$(SRCLIB)XETrapInit.obj          : XETrapInit.c, $(INCLUDES)
$(SRCLIB)XEPrivUtilsVMS.obj      : XEPrivUtilsVMS.c
$(SRCLIB)XLib_Global.obj         : XLib_Global.mar
$(SRCLIB)XEKeybCtrl.obj          : XEKeybCtrl.c 
$(SRCLIB)sleep.obj               : sleep.c
$(SRCLIB)getopt.obj              : getopt.c


