#include "stdio.h"
#include "xtraplib.h"
#include "xtraplibproto.h"
#if defined VMS && defined TCPCONN            /* to the rest of the file!!! */
#include "descrip.h"
#include "iodef.h"
#include "psldef.h"
#include "ssdef.h"
#include "file.h"
#define __SOCKET_TYPEDEFS  /* bug in in.h on VMS */
typedef unsigned short u_short;
typedef unsigned long u_long;
typedef unsigned char u_char;
#include "in.h"
#include "ucx$inetdef.h"        /* INET symbol definitions */

#ifndef lint
static char SCCSID[] = "@(#)XEStreamInternetVMS.c	1.7 - 90/09/18  ";
#endif

#define RetryCount 10

struct itlst {
     int lgth;
     struct sockaddr *hst;
      };

struct itlst_1 {
     int lgth;
     char *rmt_adrs;
     int *retlth;
      };
           
/*
 *  DESCRIPTION:
 *
 *      This function performs the VMS Internet initialization.  This 
 *      involves assigning a channel to an INET device and to a new 
 *      device_socket, create, bind the device socket to local host and listen
 *      the socket is "guaranteed" to be unique via using a socket port
 *      derived from the process' id (getpid()) and retrying RetryCount
 *      times.  The "accept" is left for the AcceptInternetStream() routine.
 *
 */
#ifdef __STDC__
int OpenInternetStream( XESTREAM *st, char *addr, CARD32 mode)
#else
int OpenInternetStream(st, addr, mode)
    XESTREAM *st;
    char     *addr;
    CARD32   mode;
#endif
{

    int status = True;
    /* Structures used to pass parameters to QIO calls. */
    /*
     * Descriptor for Inet device name.
     */ 
    struct dsc$descriptor dev = {3,DSC$K_CLASS_S,DSC$K_DTYPE_T,"BG:"};
    short   sck_parm[2];   /* Socket creation parameter */
    struct  sockaddr_in local_host; /* Socket adrs definition for lhst */
    char host[32];
    char port_str[12];
    struct  itlst lhst_adrs;
    int i;
    int vms_status;

    st->u.Q.read_mode = st->u.Q.write_mode = IO$_NOP;
    switch(mode)
    {   /* Tear down the read/write mode for Internet */
        case O_RDONLY:
            st->u.Q.read_mode = IO$_READVBLK;
            break;
        case O_RDWR:
            st->u.Q.read_mode = IO$_READVBLK;
            /* fall through to get write as well */
        case O_WRONLY:
            st->u.Q.write_mode = IO$_WRITEVBLK;
            break;
        default:
            return(False);
            break;
    }

    /*
     * Itlst for local IP address.
     */
    lhst_adrs.lgth = sizeof(local_host);
    lhst_adrs.hst = &local_host;
           
    sck_parm[0] = INET$C_TCP;     /* TCP/IP protocol */
    sck_parm[1] = INET_PROTYP$C_STREAM; /* Datagram type of socket */
    local_host.sin_family = INET$C_AF_INET;/* INET family */
    local_host.sin_addr.s_addr = INET$C_INADDR_ANY; /* Network/subnetwork*/
    memset(local_host.sin_zero, 0L, sizeof(local_host.sin_zero));
    (void)gethostname(&host,sizeof(host));

    /* In the case of Internet, the *port* is the temporary channel for
     * binding the data channel and *write_chan* and *read_chan* reference
     * the same data channel.
     */
    if ((((vms_status = sys$assign(&dev,&st->u.Q.port,PSL$C_USER,0L)))
        != SS$_NORMAL) ||
        (((vms_status = sys$assign(&dev,&st->u.Q.write_chan,PSL$C_USER,0L))
        != SS$_NORMAL)))
    {

        fprintf(stderr,
            "SIO:  Err %%x%x assigning channel in OpenInternetStream()!\n",
            vms_status);
        status = False;
    }
    /*
     * Create, bind the device socket to local host and listen.
     */
    for (i=0; i<RetryCount && status==True; i++)
    {
        local_host.sin_port = IPPORT_USERRESERVED + getpid() % 
            (1000 - RetryCount) + i;
        if (((vms_status = sys$qiow(0,st->u.Q.port,IO$_SETMODE,st->u.Q.iosb,
            0L,0L,&sck_parm,0L,&lhst_adrs,3L,0L,0L)) == SS$_NORMAL) &&
            (st->u.Q.iosb[0] == SS$_NORMAL))
        {
            break;
        }
    }
    if (i>=RetryCount)
    {   /* We failed! */
        fprintf(stderr,
            "SIO:  Error %%x%x binding socket in OpenInternetStream()!\n",
            vms_status);
        fprintf(stderr,
            "      IOSB return value, %%x%x\n", st->u.Q.iosb[0]);
        status = False;
    }
    /* encode return address in addr2 */
    if (status == True)
    {
        sprintf(port_str, "%d", local_host.sin_port);
        st->addr2_lgth = strlen(host) + strlen(port_str) + 2L;  
        if ((st->addr2 = (char *)malloc(st->addr2_lgth)) != NULL)
        {
            strcpy(st->addr2, host);
            strcpy(&st->addr2[strlen(host)+1L], port_str);
        }
        else
        {   /* no memory avail */
            fprintf(stderr, 
                "SIO:  Can't allocate memory in OpenInternetStream()!\n");
            status = False;
        }
    }
    /* No further work can be done beyond declaring the object
     * The "accept()" must be done *after* the XEConfigRequest
     * is performed.
     */
    return(status);
}


#ifdef __STDC__
int AcceptInternetStream(XESTREAM *st)
#else
int AcceptInternetStream(st)
    XESTREAM *st;
#endif
{
    int status = True;
    struct  itlst_1 rhst_adrs;
    char remote_hostaddr[16];
    int retlen;
    int vms_status;

    rhst_adrs.lgth = 16;
    rhst_adrs.rmt_adrs = &remote_hostaddr;
    rhst_adrs.retlth = &retlen;
    retlen = 0;
    st->u.Q.read_chan = st->u.Q.write_chan; /* so read_qio works */
    if (((vms_status = sys$qiow(0,st->u.Q.port,IO$_ACCESS|IO$M_ACCEPT,
        st->u.Q.iosb,0L,0L,0L,0L,&rhst_adrs,&st->u.Q.write_chan,0L,0L)) 
        == SS$_NORMAL) && (st->u.Q.iosb[0] == SS$_NORMAL))
    {
        if (st->u.Q.read_mode == IO$_READVBLK)
        {   /* We're reading! */
            status = queue_read_qio(st);
        }
    }
    else
    {
        fprintf(stderr,
            "SIO:  Error %%x%x accepting socket in AcceptInternetStream()!\n",
            vms_status);
        fprintf(stderr,
            "      IOSB return value, %%x%x\n", st->u.Q.iosb[0]);
        status = False;
    }
    return(status);
}


/*
 *  DESCRIPTION:
 *
 *      This function performs the transport specific functions for 
 *      closing the Internet connection.  This is different from CloseChan
 *      in that a QIO to de-access from the net is req'd.  Following
 *      the de-allocation, it just calls XECloseChan.
 *
 */
#ifdef __STDC__
int CloseInternetStream(XESTREAM *st)
#else
int CloseInternetStream(st)
    XESTREAM *st;
#endif
{
    int status;
    int vms_status;

    status = CloseQIOStream(st);
    if ((vms_status = sys$dassgn(st->u.Q.port)) != SS$_NORMAL)
    {
        fprintf(stderr,
            "SIO:  Err %%x%x deassigning channel in CloseInternetStream()!\n",
            vms_status);
        status = False;
    }
    return(status);
}
#endif
