/*****************************************************************************
Copyright 1987, 1988, 1989, 1990, 1991 by Digital Equipment Corp., Maynard, MA

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of Digital not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

*****************************************************************************/
#include "stdio.h"
#include "xtraplib.h"
#include "xtraplibproto.h"
#if defined VMS && defined LATCONN            /* to the rest of the file!!! */
#include "descrip.h"
#include "file.h"
#include "iodef.h"
#include "libdef.h"
#include "dvidef.h"
#include "psldef.h"
#include "jpidef.h"
#include "ssdef.h"
#include "stsdef.h"
#include "nfbdef.h"
#include "stream.h"

/* The following routines are stubbed out for future LAT I/O */

#ifdef FUNCTION_PROTOS
int OpenLATStream( XESTREAM *st, char *addr, CARD32 mode)
#else
int OpenLATStream(st, addr, mode)
    XESTREAM *st;
    char     *addr;
    CARD32   mode;
#endif
{

    int status;

    /* Need to fill in st->u.Q.write_chan and/or st->u.Q.read_chan*/

    if (Success)
    {
        status = True;
    }
    else
    {
        fprintf(stderr, "SIO:  Error xyz in OpenLATStream()!\n");
        status = False;
    }
    return(status);
}
#ifdef FUNCTION_PROTOS
int CloseLATStream( XESTREAM *st)
#else
int CloseLATStream(st)
    XESTREAM *st;
#endif
{

    int status;

    /* Need to close down st->u.Q.write_chan and/or st->u.Q.read_chan*/

    if (Success)
    {
        status = 0L;
    }
    else
    {
        fprintf(stderr, "SIO:  Error xyz in CloseLATStream()!\n");
        status = -1L;
    }
    return(status);
}

#ifdef FUNCTION_PROTOS
int ReadLATStream( XESTREAM *st, char *buf, CARD16 size)
#else
int ReadLATStream(st, buf, size)
    XESTREAM *st;
    char     *buf;
    CARD16   size;
#endif
{

    int status;

    /* Need to read from st->u.Q.read_chan */

    if (Success)
    {
        status = size;
    }
    else
    {
        fprintf(stderr, "SIO:  Error xyz in ReadLATStream()!\n");
        status = 0L;
    }
    return(status);
}

#ifdef FUNCTION_PROTOS
int WriteLATStream( XESTREAM< *st, char *buf, CARD16 size)
#else
int WriteLATStream(st, buf, size)
    XESTREAM< *st;
    char     *buf;
    CARD16   size;
#endif
{

    int status;

    /* Need to write to st->u.Q.write_chan */

    if (Success)
    {
        status = size;
    }
    else
    {
        fprintf(stderr, "SIO:  Error xyz in WriteLATStream()!\n");
        status = 0L;
    }
    return(status);
}

#ifdef FUNCTION_PROTOS
int AcceptLATStream( XESTREAM *st)
#else
int AcceptLATStream(st)
    XESTREAM *st;
#endif
{

    int status;

    /* Might need to Accept connection like DECnet & Internet */

    if (Success)
    {
        status = True;
    }
    else
    {
        fprintf(stderr, "SIO:  Error xyz in AcceptLATStream()!\n");
        status = False;
    }
    return(status);
}

#endif
